<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Core_Bform {
    
    /**
     * Factory of forms.
     * 
     * @param           string $class_name Class name without 'Form_' prefix
     * @param           array $bind_values Data 
     * @param           array $params Bform_Form params
     * @static
     * @access          public
     * @return          Bform_Form
     */
    public static function factory($class_name, array $bind_values = array(), array $params = array())
    {
        $class_name = 'Form_'.$class_name;
        
        if ( ! class_exists($class_name))
        {
            throw new Bform_Exception("Class :class_name doesn't exists!", array(':class_name' => $class_name));
        }
        
        $form = new $class_name($params);
        $form->create($bind_values);
        return $form;
    }
}