<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Core_Driver_Date extends Bform_Driver {
    
    protected function _get_value($value)
    {
        if ($value['Y'] == '' OR $value['m'] == '' OR $value['d'] == '')
        {
            $value = 0;
        }
        else
        {
            $value = "{$value['Y']}-{$value['m']}-{$value['d']}";
        }
        
        return $value;
    }
    
    protected function _set_value($value)
    {
        if (empty($value))
        {
            return NULL;
        }
        if (is_array($value))
        {
            return $value;
        }
        $array = explode('-', $value);
        if (count($array) !== 3)
        {
            throw new Bform_Exception('Date format is incorrect, correct is "Y-m-d"');
        }
        if (strlen($array[0]) !== 4 OR strlen($array[1]) !== 2 OR strlen($array[2]) !== 2)
        {
            throw new Bform_Exception('Date format is incorrect, correct is "Y-m-d"');
        }

        $value = array(
            'Y' => $array[0],
            'm' => $array[1],
            'd' => $array[2]
        );
        
        return $value;
    }
    
    public static function factory(Bform_Form $form, $name, $info = array())
    {
        return new Bform_Driver_Date($form, $name, $info);
    }

}