<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Core_Driver_Datetime extends Bform_Driver {
    
    protected function _get_value($value)
    {
        if ($value['Y'] == '' OR $value['m'] == '' OR $value['d'] == '' OR $value['H'] == '' OR $value['i'] == '')
        {
            $value = 0;
        }
        else
        {
            $value = "{$value['Y']}-{$value['m']}-{$value['d']} {$value['H']}:{$value['i']}";
        }
        
        return $value;
    }
    
    protected function _set_value($value)
    {
        if (empty($value))
        {
            return NULL;
        }
        if (is_array($value))
        {
            return $value;
        }
        list($date, $time) = explode(' ', $value);
        $date = explode('-', $date);
        $time = explode(':', $time);

        if (strlen($date[0]) !== 4 OR strlen($date[1]) !== 2 OR strlen($date[2]) !== 2 OR strlen($time[0]) !== 2 OR strlen($time[1]) !== 2)
        {
            throw new Bform_Exception('Date format is incorrect, correct is "Y-m-d H:i(:s)"');
        }

        $value = array(
            'Y' => $date[0],
            'm' => $date[1],
            'd' => $date[2],
            'H' => $time[0],
            'i' => $time[1]
        );
        
        return $value;
    }
    
    public static function factory(Bform_Form $form, $name, array $info = array())
    {
        return new Bform_Driver_Datetime($form, $name, $info);
    }

}