<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Core_Driver_Group_Checkbox extends Bform_Driver_Input_Checkbox {

    protected function _get_checked($value)
    {
        $parent = $this->parent;
        $form = $this->form;

        if ($form->is_sent())
        {
            $path = $parent->path;
            $form_data = Arr::path($form->data(), $path, array(), '.');

            if (in_array($this->value, $form_data))
            {
                $value = TRUE;
            }
        }
        else
        {
            if (is_array($parent->_value) AND in_array($this->value, $parent->_value))
            {
                $value = TRUE;
            }
        }
        
        return $value;
    }
    
    protected function _get_class($value)
    {
        $value = parent::_get_class($value);
        if ($this->parent->has_error)
        {
            $value .= ' '.Kohana::$config->load('bform.css.driver_error_class');
        }
        
        return $value;
    }
    
    protected function _set_name($value)
    {
        $value = parent::_set_name($value);
        
        $friendly_name = "{$value}";
        $friendly_name = Bform_Helper::friendly_name($friendly_name);
        $friendly_name .= '-'.url::title(text::limit_chars($this->label, 20, ''), '-', TRUE);
        
        $this->id = "bform-{$friendly_name}";
        
        return $value;
    }

    public static function factory(Bform_Form $form, $name, array $info = array())
    {
        return new Bform_Driver_Group_Checkbox($form, $name, $info);
    }
}