<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Core_Driver_Group_Radio extends Bform_Driver_Input_Radio {

    protected function _get_checked($value)
    {
        $form = $this->form;
        $driver_path = $this->parent->path;

        if ($form->is_sent())
        {
            $form_data = $form->data();
            if (($val = Arr::path($form_data, $driver_path, NULL, '.')) !== NULL AND $val == $this->value)
            {
                $value = TRUE;
            }
        }
        else
        {
            if ($this->value == $this->parent->_value)
            {
                $value = TRUE;
            }
        }
        
        return $value;
    }
    
    protected function _get_class($value)
    {
        $value = parent::_get_class($value);
        if ($this->parent->has_error)
        {
            $value .= ' '.Kohana::$config->load('bform.css.driver_error_class');
        }
        
        return $value;
    }
    
    protected function _set_name($value)
    {
        $value = parent::_set_name($value);
        
        $friendly_name = "{$value}";
        $friendly_name = Bform_Helper::friendly_name($friendly_name);
        $friendly_name .= '-'.url::title(text::limit_chars($this->label, 20, ''), '-', TRUE);
        
        $this->id = "bform-{$friendly_name}";
        
        return $value;
    }
    
    public static function factory(Bform_Form $form, $name, array $info = array())
    {
        return new Bform_Driver_Group_Radio($form, $name, $info);
    }
}