<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Core_Driver_Time extends Bform_Driver {

    protected function _set_value($value)
    {
        if (is_string($value))
        {
            $array = explode(':', $value);
            if (empty($array[0]) OR empty($array[1]))
            {
                throw new Bform_Exception;
            }
            
            $value = array(
                'H' => $array[0],
                'i' => $array[1]
            );
        }
        return $value;
    }
    
    protected function _get_value($value)
    {
        if (is_array($value))
        {
            if (empty($value['H']) OR empty($value['i']))
            {
                return 0;
            }
            $value = "{$value['H']}:{$value['i']}";
        }
        return $value;
    }
    
    public static function factory(Bform_Form $form, $name, array $info = array())
    {
        return new Bform_Driver_Time($form, $name, $info);
    }
}