<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Core_Validator_Driver_Compare extends Bform_Validator_Driver {
	
    /**
     * Stores a driver name which is used to retrieve sended value from that driver
     * 
     * @var string
     */
    protected $_compare_driver_name = NULL;

    public function __construct(Bform_Driver $driver, array $options = array())
    {
        if ( ! isset($options['message'])) 
        {
            throw new Bform_Exception("Option 'message' is required!");
        }

        if ( ! isset($options['compare'])) 
        {
            throw new Bform_Exception("Option 'compare' is required!");
        }
        
        $this->_compare_driver_name = $options['compare'];
        unset($options['compare']);
        
        parent::__construct($driver, $options);
    }

    /**
     *
     * @throw Bform_Validator_Exception_Driver
     */
    public function validate()
    {
        $compare_driver = $this->driver()->form->drivers->{$this->_compare_driver_name};
        if (empty($compare_driver))
        {
            throw new Bform_Exception("Compare driver ':name' doesnt exists!", array(':name' => $this->_compare_driver_name));
        }
        
        if ($compare_driver->value != $this->driver()->value)
        {
            throw new Bform_Validator_Exception_Driver($this);
        }
    }
}