<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Core_Validator_Driver_File_Size extends Bform_Validator_Driver {
    
    protected $_message = "Rozmiar pliku jest zbyt duży! Maksymalny dopuszczalny rozmiar to :filesize!";

    public function __construct(Bform_Driver $driver, array $options = array())
    {
        if ( ! isset($options['filesize']))
        {
            throw new Bform_Exception("The 'filesize' option is required!");
        }
        parent::__construct($driver, $options);
    }

    public function validate()
    {
        if (upload::valid($this->driver()->value) AND upload::not_empty($this->driver()->value) AND ! upload::size($this->driver()->value, $this->_options['filesize']))
        {
            throw new Bform_Validator_Exception_Driver($this);
        }
    }
}