<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Core_Validator_Driver_Length extends Bform_Validator_Driver {
    
    public function __construct(Bform_Driver $driver, array $options = array())
    {    
        if ( ! isset($options['min']))
        {
            $options['min'] = FALSE;
        }
        
        if ( ! isset($options['max']))
        {
            $options['max'] = FALSE;
        }
        
        parent::__construct($driver, $options);
    }
	
    public function validate() 
    {
        $length = utf8::strlen($this->driver()->value);

        if ($this->_options['min'] !== FALSE AND $length < $this->_options['min']) 
        {
            if (empty($this->_message))
            {
                $this->_message = "Wprowadzony tekst jest zbyt krótki, minimalnie :min znaków!";
            }
            throw new Bform_Validator_Exception_Driver($this);
        }

        if ($this->_options['max'] !== FALSE AND $length > $this->_options['max']) 
        {
            if (empty($this->_message))
            {
                $this->_message = "Wprowadzony tekst jest zbyt długi, maksymalnie :max znaków!";
            }
            throw new Bform_Validator_Exception_Driver($this);
        }
    }
}