<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Core_Validator_Driver_Range extends Bform_Validator_Driver {

    public function __construct(Bform_Driver $driver, array $options = array()) 
    {   
        if ( ! isset($options['min']))
        {
            $options['min'] = FALSE;
        }
        if ( ! isset($options['max']))
        {
            $options['max'] = FALSE;
        }
        
        parent::__construct($driver, $options);
    }
    
    public function validate() 
    {
        $value = $this->driver()->value;
        if (empty($value)) 
        {
            return;
        }

        $value = str_replace(',', '.', $value);

        if ( ! is_numeric($value)) 
        {
            if (empty($this->_message))
            {
                $this->_message = 'Wprowadzona wartość nie jest liczbą!';
            }
            throw new Bform_Validator_Exception_Driver($this);
        }
        if ($this->_options['min'] !== FALSE AND $value < $this->_options['min'])
        {
            if (empty($this->_message))
            {
                $this->_message = 'Wprowadzona wartość jest za niska, minimalna dopuszczalna wartość to :min!';
            }
            throw new Bform_Validator_Exception_Driver($this);
        }

        if ($this->_options['max'] !== FALSE AND $value > $this->_options['max']) 
        {
            if (empty($this->_message))
            {
                $this->_message = 'Wprowadzona wartość jest za wysoka, maksymalna dopuszczalna wartość to :max!';
            }
            throw new Bform_Validator_Exception_Driver($this);
        }
    }
}