<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Core_Validator_Driver_Regex extends Bform_Validator_Driver {
	
    protected $_regex = '';

    public function __construct(Bform_Driver $driver, array $options = array()) 
    {
        if ( ! isset($options['regex'])) 
        {
            throw new Bform_Exception("Option 'regex' is required!");
        }
        
        $this->_regex = $options['regex'];
        unset($options['regex']);
        
        parent::__construct($driver, $options);
    }

    public function validate() 
    {
        $value = $this->driver()->value;
        if (empty($value)) 
        {
            return;
        }
        
        if ( ! preg_match($this->_regex, $this->driver()->value))
        {
            throw new Bform_Validator_Exception_Driver($this);
        }
    }
}