<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Core_Validator_Driver_Required extends Bform_Validator_Driver {

    protected $_message = 'Pole jest wymagane!';
	
    public function validate()
    {
        $value = $this->driver()->value;
        // is file or multiselect or date or datetime
        if (is_array($value)) 
        {
            // is file
            if (upload::valid($value)) 
            {
                if ( ! upload::not_empty($value))
                {
                    throw new Bform_Validator_Exception_Driver($this);
                }
            }
            else // is group of checkboxes or multiselect
            {
                if ( ! isset($value[0]))
                {
                    throw new Bform_Validator_Exception_Driver($this);
                }
            }
        }
        else
        {
            if (empty($value))
            {
                throw new Bform_Validator_Exception_Driver($this);
            }
        }
    }
}