<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Core_Validator_Driver_URL extends Bform_Validator_Driver_Regex {
	
    const REGEX_URL = '~^
        ((http|https|ftp|ftps)://)?                # protocol
        (
        ([a-z0-9-]+\.)+[a-z]{2,6}               # a domain name
          |                                     #  or
        \d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}      # a IP address
        )
        (:[0-9]+)?                              # a port (optional)
        (/?|/\S+)                               # a /, nothing or a / with something
        $~ix';
    
    protected $_message = 'To nie jest adres URL!';

    public function __construct(Bform_Driver $driver, array $options = array()) 
    {
        $options['regex'] = self::REGEX_URL;
        parent::__construct($driver, $options);
    }
}