<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Core_Validator_Driver_Youtube extends Bform_Validator_Driver {
    
    protected $_message = 'Nie znaleziono ID wideo w linku!';

    public function validate() 
    {
        $value = $this->driver()->value;
        if (empty($this->driver()->value))
        {
            return;
        }
        // $ytv_id_len = 11; // This is the length of YouTube's video IDs
        // The ID string starts after "v=", which is usually right after
        // "youtube.com/watch?" in the URL
        $id_starts = strpos($this->driver()->value, "?v=");
        // In case the "v=" is NOT right after the "?" (not likely, but I like to keep my
        // bases covered), it will be after an "&":
        if ($id_sarts === FALSE)
        {
            $id_starts = strpos($this->driver()->value, "&v=");
        }
        // If still FALSE, URL doesn't have a vid ID
        if ($id_starts === FALSE)
        {
            throw new Bform_Validator_Exception_Driver($this);
        }
    }
}