<?php
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
abstract class Bform_Core_Validator_Exception extends Exception {
    
    /**
     * 
     * @var array
     */
    protected $_options = array();
    
    /**
     * 
     * @var Bform_Validator
     */
    protected $_validator = NULL;
    
    public function __construct()
    {
        parent::__construct('Validation error', 37);
    }
    
    /**
     *
     * @return Bform_Validator 
     */
    public function validator()
    {
        return $this->_validator;
    }
    
    /**
     * Getter
     * 
     * @return bool
     * @see Bform_Validator_Exception_Driver::$_stop_validating
     */
    public function stop()
    {
        return ( ! empty($this->_options['stop']));
    }
    
    /**
     * Getter
     * 
     * @return array
     */
    public function message() 
    {
        return $this->validator()->message();
    }
    
}