<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
abstract class Bform_Core_Validator_Form extends Bform_Validator {
    
    /**
     * @var Bform_Form 
     */
    protected $_form = NULL;
    
    public function __construct(Bform_Form $form, array $options = array())
    {
        parent::__construct($options);
        $this->_form = $form;
    }
    
    /**
     *
     * @param string $name
     * @return Bform_Driver
     */
    public function driver($name = NULL)
    {
        if ($name === NULL)
        {
            return $this->_driver;
        }
        
        return $this->form()->drivers->$name;
    }
    
    /**
     *
     * @return Bform_Form
     */
    public function form()
    {
        return $this->_form;
    }
}