<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
abstract class Bform_Plugin_Blocks_Block {
    
    protected $_drivers = array();
    protected $_drivers_children = array();
    protected $_parents = array();
    protected $_children = array();
    
    protected $_type = NULL;
    protected $_title = NULL;
    protected $_info = array();
    
    protected $_depth = 0;
    
    public static function factory(array $args)
    {
        $title = $args[0];
        $info = isset($args[1]) ? $args[1] : array();
        $type = isset($info['type']) ? $info['type'] : Bform_Plugin_Blocks::BLOCK_FIELDSET;
        
        if ($type === Bform_Plugin_Blocks::BLOCK_FIELDSET)
        {
            return new Bform_Plugin_Blocks_Fieldset($type, $title, $info);
        }
    }
    
    public function __construct($type, $title, $info = array())
    {
        $this->_type = $type;
        $this->_title = $title;
        $this->_info = $info;
    }
    
    public function html_attributes()
    {
        return Arr::get($this->_info, 'html', array());
    }
    
    public function parents($value = NULL)
    {
        if ($value === NULL)
        {
            return $this->_parents;
        }
        foreach ($value as $block)
        {
            $this->_parents[] = $block;
            $block->child($this);
        }
    }
    
    public function child(Bform_Plugin_Blocks_Block $child)
    {
        $this->_children[] = $child;
    }
    
    public function driver(Bform_Driver $driver)
    {
        $this->_drivers[] = $driver;
        $this->_drivers_children[] = $driver;
        foreach ($this->parents() as $block)
        {
            $block->_drivers_children[] = $driver;
        }
    }
    
    public function drivers()
    {
        return $this->_drivers;
    }
    
    public function is($type)
    {
        if ($this->_type === $type)
        {
            return TRUE;
        }
        return FALSE;
    }
    
    public function title()
    {
        return $this->_title;
    }
}