<?php 
/**
* @author  		Michal Baniowski <baniczek@gmail.com>
* @link  		http://www.michalbaniowski.pl
* 
* @package 		bform
*/
class Bform_Plugin_Group extends Bform_Plugin {
    
    protected $_group = NULL;
    
    public function extend_form_group_start($params)
    {
        $name = $params[0];
        $info = $params[1];
        $this->_group = Bform_Driver_Group::factory($this->form(), $name, array(), $info);
        
        return self::RESULT_PLUGIN;
    }
    
    public function plugin_add($params)
    {   
        $value = $params[0];
        $label = $params[1];
        $info  = ( ! empty($params[2]) ? $params[2] : array());
        $info['value'] = $value;
        $info['label'] = $label;
        $info['parent'] = $this->_group;
        
        if ($this->_group->is_array)
        {
            $this->_group->elements[] = Bform_Driver_Group_Checkbox::factory($this->form(), $this->_group->name, $info);
        }
        else
        {
            $this->_group->elements[] = Bform_Driver_Group_Radio::factory($this->form(), $this->_group->name, $info);
        }
        
        return self::RESULT_PLUGIN;
    }
    
    public function plugin_group_end()
    {
        $this->form()->drivers->{$this->_group->name} = $this->_group;
        return self::RESULT_FORM;
    }
}