# Drivers

## Available drivers types

You can add form element by using i.e following methods:

    $this
            ->add_input_text('name', array('label' => 'Name'))
            ->add_input_text('email', array('label' => 'Email'))
            ->add_textarea('message', array('label' => 'Your opinion'))
            ->add_input_submit('Send!');



As you see name of the of the input is included in called method name which is prefixed by "add_" string. You can use
following inputs:

1.   Input text ( <b>add_input_text</b> )
2.   Input password ( <b>add_input_password</b> )
3.   Input file ( <b>add_input_file</b> )
4.   Input hidden ( <b>add_input_hidden</b> )
5.   Select ( <b>add_select</b> )
6.   Select multiple ( <b>add_select_multiple</b> )
7.   Button ( <b>add_button</b> or its alias: <b>add_input_submit</b> )
8.   Textarea ( <b>add_textarea</b> )
9.   Checkbox or radio group ( <b>add_group</b> )
10.  Bool ( <b>add_bool</b> ); its checkbox with value equal "1", by default is <b>not</b> required
11.  Date ( <b>add_date</b> ); its group of selects; date is in "Y-m-d" format
12.  Datetime ( <b>add_date_time</b> ); its group of selects, date is in "Y-m-d H:i" format
13.  Time ( <b>add_time</b> ); its group of selects, time is in "H:i" format
14.  HTML ( <b>add_html</b> ); non-validated and has no value
<br/><br/>

## Accepted params


Most of form drivers accept identical parameters.
<br/><br/>


For input text, input password, input file, textarea, bool, date, 
datetime and time it will be:

1.   $name: string, can be namespaced, ex: "article[title]"
2.   $info: associative array, contains data passed into driver.
<br/><br/>


For select, select multiple:

1.   $name
2.   $elements: associative array of (array of (just like Kohana_Form::select()) string, keys are values,
3.   $info
<br/><br/>

For group:

1.   $name, if name is ended by "[]" then group will contains checkboxes, otherwise - radio
2.   $elements: associative array, keys are values, values are group element label
3.   $info
<br/><br/>

For button, input hidden:

1.   $name
2.   $value: string
3.   $info
<br/><br/>

For input submit:

1.   $value
2.   $info
<br/><br/>

And for HTML:

1.   $html: string or object containing __toString() method
2.   $info
<br/><br/>

## $info variable

## Managing drivers data

Driver base class is using __get() and __set() magic methods. To retrieve data use:

    $classes = $form->{'article[title]}->class

and to set data:

    $form->article_title->class = "hidden";
<br/><br/>


If for some reason you must manipulate passed or retrieved value then you can create method with name in format
"\_set\_\<var name\>($var\_value)" or "\_get\_\<var name\>". Ie:

    protected function _set_label($value)
    {
        $value = UTF8::strtoupper($value);
        return $value;
    }

    protected function _get_class($value)
    {
        if ($this->has_error)
        {
            $value .= " error ";
        }
        return $value;
    }

To prevent calling above methods add "_" to var name:

    $class = $form->article_title->_class;
    $form->article_title->_label = "Article title";

## More or less useful driver values and methods

### values

1.   form - form of the driver
2.   has_error - if validation fails
4.   is_array - true if driver is group of checkbox or multiselect
5.   is_namespaced
6.   driver_template, driver_layout
7.   path - used by Kohana_Arr::path() and Kohana_Arr::set_path()
8.   html_before, html_after - code displayed before/after input
9.   html_attributes - retrieve all allowed html attributes.