# Validating data

There are 2 types of validators: driver validator and form validator.
<br/><br/>


Driver validator checks value of driver, form validator can validate more than
one values (driver validator too) but error can be optionally assigned to any driver - in case when
one value depends on another value.

## Driver Validator

To add validator to input use Bform_Form::add_validator()
<br/><br/>

.
Accepted params:

1.   $driver_name: string
2.   $validator_class_name: string
3.   $options: array, passed to validator class
<br/><br/>


Example:

    $this
            ->add_input_text('article[title]', array('label' => 'Title'))
            ->add_validator('article[title]', 'Bform_Validator_Length', array('min' => 5, 'max' => 64))
            ->add_input_submit('Edit!');

Each validator has a message displayed on error. You can overwrite it by passing
in $options array string with key "message" or extending validator class $_message var.
<br/><br/>


Displayed message is I18n compatible - it uses a Kohana "__()" function.
<br/><br/>


In message you can display any value of $options
array by adding to your message string in format ":\<options_key\>", for example ":min". Also sended value can be displayed by writing
":value".
<br/><br/>


Available validators:

1.   File size ( <b>Bform_Validator_File_Size</b> )
2.   Image ( <b>Bform_Validator_File_Image</b> )
3.   Compare ( <b>Bform_Validator_Compare</b> )
4.   Email ( <b>Bform_Validator_Email</b> )
5.   Float ( <b>Bform_Validator_Float</b> )
6.   HTML ( <b>Bform_Validator_Html</b> )
7.   Integer ( <b>Bform_Validator_Integer</b> )
8.   Length ( <b>Bform_Validator_Length</b> )
9.   Numeric ( <b>Bform_Validator_Numeric</b> )
10.  Range ( <b>Bform_Validator_Range</b> )
11.  Regex ( <b>Bform_Validator_Regex</b> )
12.  Url ( <b>Bform_Validator_Url</b> )
13.  Youtube ( <b>Bform_Validator_Youtube</b> )
<br/><br/>


To start validating a form just call "Bform_Form::validate()" method. This method also fill form with sended values after checking if
form was submitted.

## Form validators

<b>TODO</b>

## Validator $options array

<b>TODO</b>