# input

## Bform_Form::bind()

Use Bform_Form::bind(). It must be called after creating all form elements.
Namespacing (multidimentional arrays) are supported.


## On creating form

Example:

    $article = ORM::factory('Article', 1);
    $form = Bform_factory('Admin_Article_Edit', $article->as_array());

## $info param

Example:

    $this
            ...
            ->add_input_text('article[title]', array('label' => 'Title', value => 'Article 1'))
            ...

# output

## Bform_Form::values()

Use Bform_Form::values() method to get values of sended (or not) form.
Its accept one parameter - an integer describing which values should be returned.
For now the following options are available:
<br/><br/>


1.   Get empty or not empty values
2.   Get values with or without a "form_id" driver value (described later)
3.   Mixes of above.
<br/><br/>


Option can be changed by passing a integers ( optionally after binary 
operation).
<br/><br/>


The constants:

1.   Bform_Form::VALUES_NOT_EMPTY
2.   Bform_Form::VALUES_WITHOUT_FORM_ID
<br/><br/>


<b>Default</b>: ~ ( Bform_Form::VALUES_NOT_EMPTY ) & Bform_Form::VALUES_WITHOUT_FORM_ID
<br/><br/>


<b>Note:</b> Bform_Form::values() do not returns files values.
<br/><br/>


Result is a multidimentional associative array if namespaced drivers are present, otherwise
associative array; keys are driver names.

## Bform_Form::files()

Use that method to get values from input file drivers.
Its accept one parameter - boolean which describes if return only not empty values.
Default is set to true.
<br/><br/>


Result is an array with keys equal driver name, values are just copy from $_FILES
array.

## From driver

You can also get value from single driver. For example:

    $form->article_title->value;
    $form->{'article[article_title]'}->value;